=== debian/changelog ===
suitesparse (1:7.1.0+dfsg-3) unstable; urgency=medium

  * spqr-32bit.patch: new patch taken from upstream.
    Fixes segfault in SPQR on 32-bit architectures.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 02 Aug 2023 12:34:29 +0200

suitesparse (1:7.1.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 16 Jul 2023 19:13:03 +0200

suitesparse (1:7.1.0+dfsg-1) experimental; urgency=medium

  * New upstream version 7.1.0+dfsg
  * d/copyright: reflect upstream changes
  * buildflags.patch: remove patch, applied upstream
  * d/rules: manually cleaning some outputs is no longer needed
  * SOVERSION bump of librbio (3 → 4)

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 07 Jul 2023 09:09:32 +0200

suitesparse (1:7.0.1+dfsg-1) experimental; urgency=medium

  * New upstream version 7.0.1+dfsg
  * d/copyright: reflect upstream changes
  * Overhaul packaging following upstream move to CMake for all libraries.
  * Bump SOVERSIONs for all libraries
  * SLIP_LU library has been renamed to SPEX
  * libmetis-dev is no longer a build dependency (CHOLMOD now has its own
    embedded copy)
  * texlive-2022.patch, mongoose-build.patch: no longer needed
  * Add support for nocheck, nodoc and terse in DEB_BUILD_OPTIONS
  * Bump Standards-Version to 4.6.2
  * Enable link-time optimizations (LTO)
  * Ship README.md in libsuitesparse-doc
  * No longer build documentation in arch-only mode (Closes: #960766)

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 28 May 2023 12:05:50 +0200
